package com.qmth.teachcloud.common.cache;

import com.qmth.teachcloud.common.bean.dto.UserAuthenticationDto;
import com.qmth.teachcloud.common.contant.SpringContextHolder;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.enums.RoleTypeEnum;
import com.qmth.teachcloud.common.util.RedisUtil;

import java.util.Objects;
import java.util.concurrent.TimeUnit;

/**
 * @Description: 武大开发鉴权用户临时授权cache
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/6/29
 */
public class ThirdUserAuthCacheUtil {
    private static RedisUtil redisUtil = SpringContextHolder.getBean(RedisUtil.class);

    public static void setAuthCode(UserAuthenticationDto userAuthenticationDto) {
        redisUtil.set(RedisKeyHelper.thirdUserAuth(userAuthenticationDto.getUid()), userAuthenticationDto.getCode(), SystemConstant.REDIS_THIRD_USER_AUTH_EXPIRE_TIME, TimeUnit.SECONDS);
    }

    public static String getAuthCode(String key) {
        return (String) redisUtil.get(RedisKeyHelper.thirdUserAuth(key));
    }

    public static void deleteAuthCode(String key) {
        redisUtil.delete(RedisKeyHelper.thirdUserAuth(key));
    }

    public static void setAuthReturnUrl(String key, String url) {
        redisUtil.set(RedisKeyHelper.thirdUserAuthReturnUrl(key), url);
    }

    public static String getAuthReturnUrl(String key) {
        return (String) redisUtil.get(RedisKeyHelper.thirdUserAuthReturnUrl(key));
    }

    public static void deleteAuthReturnUrl(String key) {
        redisUtil.delete(RedisKeyHelper.thirdUserAuthReturnUrl(key));
    }

    public static void setAuthRole(String key, RoleTypeEnum role) {
        redisUtil.set(RedisKeyHelper.thirdUserAuthRole(key), role);
    }

    public static RoleTypeEnum getAuthRole(String key) {
        return Objects.nonNull(redisUtil.get(RedisKeyHelper.thirdUserAuthRole(key))) ? RoleTypeEnum.valueOf((String) redisUtil.get(RedisKeyHelper.thirdUserAuthRole(key))) : null;
    }

    public static void deleteAuthRole(String key) {
        redisUtil.delete(RedisKeyHelper.thirdUserAuthRole(key));
    }
}
